//+------------------------------------------------------------------+
//|                                             FFS_NetPipChange.mq4 |
//|                                            Release date 20070205 |
//+------------------------------------------------------------------+

/* 
READ ME FIRST..
I have nothing to do with www.forexforsmarties.com. 
You use these tools at YOUR OWN RISK.
I do not endorse or sell FFS methods or products in any way.
These tools are provided FREE of charge, I wish to promote the development of MT4 tools and minds
of those who trade FFS to get the best 'How to FFS tools'. So we all can trade FFS thru easy
and tough times. As the Forex market gives and takes away fortunes ! To make 5% monthly 
compounding over 10 years is not easy when the forex beast changes. 

Use with 
FFS_Trend_Basic
FFS_Correlation
FFS_CrossMA
FFS_CrossTiming
FFS_NetPipChange

IMPORTANT : Make sure the 'IndexType' is the same within each MT4 tool.
The FFS_Mode should be set as BUY, to mirror the FFS Calcutator.

This is like the standard 'Rate Of Change' indicator, but I have made it to include all 
the pairs in the hedge combination.

The standard rate of change just asks the difference between the current close and the
close N periods ago. You can see that here with the RED line on the chart, Color1.
This does not take into account the range from the high and low between the period of change.
As forex is 24 hours, the range is more important. You may have entered your hedge at the top of the 
combination hedges high, and not at the combination hedges close. So close means nothing.

So per pair within the hedge combination,  find the pip range from the high and low for the period, 
if current close is greater than close N periods ago this will be a positive move, if not it
would be negative. As all pairs have been converted to the same price scale, add all the pips  
(high - low) ranges together to get the hedge combination NetPipChange. See Color 2, Lime line.

As a timing tool, it seams it would be best to enter the hedge position in a when FFS_Mode is 
on a BUY when this indicator is below zero. Then you can catch the swing back up above zero. Toggle 
between 2,5,10,15 and 20 periods to see pip change effect.

Caution, this is fixed peirod calculation, its quite possibe that there can be multiple days
in a row when the peirod pip change is negative. (ie it does not return to zero immediately)

Within the FFS_Trend tool I have a placed the same code for pip change summary in the Trainspotting
area in the main chart. Set you account up to withstand the worse case negative pip change. The 
GOOD news is that it does swing violently up and down generating plenty of room for profits. 
How violently will depend on the hedge combination you choose ( ie EURUSD / USDCHF is safest!)

These calculations assume an equal weight between all the pairs in the 
FFS hedge combination. That each pair pip value is, at best it can be, to be
of the same value.
Example...
EURUSD pip value 100k lots is $10.00
USDCHF pip value 100k lost is $7.97 ( 1/1.2532 * 10 , as at 20070127)
so 1.25 lot must be trades to equal the EURUSD $10 pip value.


This is the index selection format
1. EUR/USD, USD/CHF
2. EUR/USD, USD/CHF, GBP/USD
3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
4. EUR/USD, USD/CHF, USD/JPY
5. EUR/USD, GBP/USD, USD/JPY
6. USD/CHF, GBP/USD
7. USD/CHF, GBP/USD, USD/JPY
8. GBP/USD, USD/JPY
*/

#property copyright "icm63 (user name at Forex-TSD)"
#property link      "Forex-TSD"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Red
#property  indicator_color2  Lime
#property  indicator_level1  0
#property  indicator_level2  -300
#property  indicator_level3  -600
#property  indicator_level4  -900
#property  indicator_level5  -1200
#property  indicator_level6  300
#property  indicator_level7  600
#property  indicator_level8  900


//---- indicator parameters
extern int IndexType =3; //Inputs 1 to 8,  FFS Index see above
extern int RPeriod = 5; // Inputs 2 to 30, Period of change

//SYMBOLS for IBFX Mini change EURUSD to EURUSDm
string sEURUSD = "EURUSD";
string sGBPUSD = "GBPUSD";
string sUSDCHF = "USDCHF";
string sUSDJPY = "USDJPY";


//---- indicator buffers
double Change1[];
double Change2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(2);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexDrawBegin(0, RPeriod);
   SetIndexLabel(0,"NetPip_C");
   SetIndexBuffer(0, Change1);

   SetIndexStyle(1, DRAW_LINE);
   SetIndexDrawBegin(1, RPeriod);
   SetIndexLabel(1,"NetPip_HL");
   SetIndexBuffer(1, Change2);
  
   
   
   IndicatorShortName("FFS_NetPipChange Index " + IndexType+" Period(" 
   + RPeriod+")");
//---- initialization done
   return(0);
  }
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if (counted_bars>0)counted_bars--;
   else counted_bars = 1;
   limit=Bars-counted_bars;
   double RES, EUR, CHF, GBP, JPY, RES1, EUR1, CHF1, GBP1, JPY1;
   double EURH, EURL, GBPH, GBPL, CHFH, CHFL, JPYH, JPYL;
  

//---- calculation
// From left to Right on Chart
   for(int i = limit; i >= 0; i--)
     {   
     
      EUR = (iClose(sEURUSD, 0, i) - iClose(sEURUSD, 0, i + RPeriod))*10000;
      GBP = (iClose(sGBPUSD, 0, i) - iClose(sGBPUSD, 0, i + RPeriod))*10000;
      CHF = (iClose(sUSDCHF, 0, i) - iClose(sUSDCHF, 0, i + RPeriod))*10000;
      JPY = (iClose(sUSDJPY, 0, i) - iClose(sUSDJPY, 0, i + RPeriod))*100;
      
      if( EUR >= 0)
         {
           EUR1 = (iHigh(sEURUSD, 0, i) - iLow(sEURUSD,0,iLowest(sEURUSD, 0, MODE_LOW, RPeriod, i  )))*10000; 
         }
      else
         {
           EUR1 = (iLow(sEURUSD, 0, i) - iHigh(sEURUSD,0,iHighest(sEURUSD, 0, MODE_HIGH, RPeriod, i  )))*10000; 
         }
         
      if(GBP >= 0)
         {
           GBP1 = (iHigh(sGBPUSD, 0, i) - iLow(sGBPUSD,0,iLowest(sGBPUSD, 0, MODE_LOW, RPeriod, i  )))*10000; 
         }
      else
         {
           GBP1 = (iLow(sGBPUSD, 0, i) - iHigh(sGBPUSD,0,iHighest(sGBPUSD, 0, MODE_HIGH, RPeriod, i  )))*10000; 
         }
         
         
     if(CHF >=0 )
         {
           CHF1 = (iHigh(sUSDCHF, 0, i) - iLow(sUSDCHF,0,iLowest(sUSDCHF, 0, MODE_LOW, RPeriod, i  )))*10000; 
         }
      else
         {
           CHF1 = (iLow(sUSDCHF, 0, i) - iHigh(sUSDCHF,0,iHighest(sUSDCHF, 0, MODE_HIGH, RPeriod, i  )))*10000; 
         }
         
      if(JPY >=0)
         {
           JPY1 = (iHigh(sUSDJPY, 0, i) - iLow(sUSDJPY,0,iLowest(sUSDJPY, 0, MODE_LOW, RPeriod, i  )))*100; 
         }
      else
         {
           JPY1 = (iLow(sUSDJPY, 0, i) - iHigh(sUSDJPY,0,iHighest(sUSDJPY, 0, MODE_HIGH, RPeriod, i  )))*100; 
         }
         
      
      
      
       switch(IndexType)
               {
               case 1:
                     //1. EUR/USD, USD/CHF"
                     RES = EUR + CHF;
                     RES1 = EUR1 + CHF1;
                     break;
               case 2:
                     //2. EUR/USD, USD/CHF, GBP/USD
                     RES = EUR + CHF + GBP;
                     RES1 = EUR1 + CHF1 + GBP1;
                     break;
               case 3:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     RES = EUR + CHF +GBP + JPY;
                     RES1 = EUR1 + CHF1 + GBP1 + JPY1;
                     break;
               case 4:
                     //4. EUR/USD, USD/CHF, USD/JPY
                     RES = EUR + CHF + JPY;
                     RES1 = EUR1 + CHF1 + JPY1;
                     break;
               case 5:
                     //5. EUR/USD, GBP/USD, USD/JPY
                     RES = EUR + GBP + JPY;
                     RES1 = EUR1 + GBP1 + JPY1;
                     break;
               case 6:
                     //6. USD/CHF, GBP/USD
                     RES =  CHF + GBP ;
                     RES1 = CHF1 + GBP1;
                     break;
               case 7:
                     //7. USD/CHF, GBP/USD, USD/JPY
                     RES = CHF + GBP + JPY;
                     RES1= CHF1 + GBP1 + JPY1;
                     break;  
               case 8:
                     //8. GBP/USD, USD/JPY 
                     RES =  GBP + JPY;
                     RES1= GBP1 + JPY1;
                     break;
               default:
                     //3. EUR/USD, USD/CHF, GBP/USD, USD/JPY
                     RES = EUR + CHF + GBP + JPY;
                     RES1 = EUR1 + CHF1 + GBP1 + JPY1;
                     break;
              }
               Change1[i] = RES;
               Change2[i] = RES1;       
     }   
     
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

